#include "PD_LgtSpdLmt.h"

using namespace ADC;
using namespace ADC::PD_LgtSpdLmt;

LgtSpdLmt::LgtSpdLmt(const PD::PD_Input &pd_input,
                     const ADC::PD_LgtSpdLmt::LastCyc_SpdLmtInfo &spdlmtinfo)
{
    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_id_01 == static_cast<uint8_t>(0) &&
        pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_id_02 == static_cast<uint8_t>(0))
    {
        SignSpdLmtCalu_Trg01 = false;
        SignSpdLmtCalu_Trg02 = false;
    }

    else
    {
        this->SlecSpdLmt_id = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_id_01;
        this->SlecSpdVal = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_val_01;
        this->SlecSpdDist = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_dist_01;
        this->SlecSpdLmt_id_2nd = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_id_02;
        this->SlecSpdVal_2nd = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_val_02;
        this->SlecSpdDist_2nd = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).longt_info.sign_spd_limit_dist_02;
        JudgeSpdLmt_ThrsDistCalu(pd_input, spdlmtinfo);
    }
}

void LgtSpdLmt::JudgeSpdLmt_ThrsDistCalu(const PD::PD_Input &pd_input,
                                         const ADC::PD_LgtSpdLmt::LastCyc_SpdLmtInfo &spdlmtinfo)
{

    float VehCurSpd = pd_input.VSE_LgtVehSpd;
    // bool SigSpdLmtFlg = false;
    // bool SigSpdLmtFlg_02 = false;

    // analysis data
    // if (SlecSpdLmt_id == static_cast<uint8_t>(255))
    // {

    //     DLOG(INFO) << "@@ "
    //                << "\tSpdLmt_id01: " << SlecSpdLmt_id << std::endl;
    // }

    // SpdLmt_id = 255:  during ramp case,LgtSpdLmt doestn't work,means SpdLmtFlg is false

    if ((SlecSpdLmt_id == static_cast<uint8_t>(0)) || (SlecSpdLmt_id == static_cast<uint8_t>(255)) || (VehCurSpd <= SlecSpdVal) || (SlecSpdVal <= LgtSpdLmtThrsVal)) // VehCurSpd and SlecSpdVal relationship
    {
        SignSpdLmtCalu_Trg01 = false;
        // DLOG(INFO) << "testtrg01" << std::endl;
    }
    else
    {

        // calculation sign01 base distance up threshold and low htreshold
        SignSpdLimt_Updist = (pow(SlecSpdVal, 2) - pow(VehCurSpd, 2)) / (2 * SignSpdLimt_minacc);
        SignSpdLimt_Lowdist = (pow(SlecSpdVal, 2) - pow(VehCurSpd, 2)) / (2 * SignSpdLmt_maxacc);

        // calculation sign01 base time up threshold and low htreshold

        float SignSpdLimt_EnblDist = 800.0f;

        // calculation sign01 base distance up threshold and low htreshold
        if ((SlecSpdLmt_id_2nd != static_cast<uint8_t>(0)) && (SlecSpdVal_2nd < VehCurSpd))
        {
            float SignSpdLimt_EnblDist_2nd = 200.0f;
            SignSpdLimt_Updist_2nd = (pow(SlecSpdVal_2nd, 2) - pow(VehCurSpd, 2)) / (2 * SignSpdLimt_minacc);
            SignSpdLimt_Lowdist_2nd = (pow(SlecSpdVal_2nd, 2) - pow(VehCurSpd, 2)) / (2 * SignSpdLmt_maxacc);
            if (SignSpdLimt_Updist_2nd >= (SignSpdLimt_EnblDist + SignSpdLimt_EnblDist_2nd))
            {
                SignSpdLimt_Updist_2nd = SignSpdLimt_EnblDist + SignSpdLimt_EnblDist_2nd;
            }
            if (SlecSpdDist_2nd <= SignSpdLimt_Updist_2nd)
            {
                SignSpdLmtCalu_Trg02 = true;
            }
        }

        if (SignSpdLimt_Updist >= SignSpdLimt_EnblDist)
        {
            SignSpdLimt_Updist = SignSpdLimt_EnblDist;
        }

        if (SlecSpdDist <= SignSpdLimt_Updist) // less than updist and spdlimt work
        {

            SignSpdLmtCalu_Trg01 = true;
        }

        // bool LgtSpdLmtDebncFlg = true;  //
    }

    // LgtSpdLmt Debounce logic
    // DLOG(INFO) << std::endl;
    // DLOG(INFO) << "NoHdTrg01: " << SignSpdLmtCalu_Trg01 << std::endl;
    // DLOG(INFO) << std::endl;

    if (spdlmtinfo.LastCyc_SpdLmtFlg == true && (SignSpdLmtCalu_Trg01 == false) &&
        (spdlmtinfo.LastCyc_SpdLmtId == SpdLmtType2MatchID(spdlmtinfo)) &&
        SlecSpdLmt_id != uint8_t(255))
    {
        SignSpdLmtCalu_Trg01 = true;
        HdSignSpdLmtCalu_Trg01 = true;
    }
#ifdef GLOG
    DLOG(INFO) << "LastCyc_SpdLmtFlg: " << spdlmtinfo.LastCyc_SpdLmtFlg << "\tHdTrg01: "
               << SignSpdLmtCalu_Trg01 << "\tLastCyc_SpdLmtId: " << int(spdlmtinfo.LastCyc_SpdLmtId)
               << "\tCurSpdLmtid: " << int(SpdLmtType2MatchID(spdlmtinfo)) << std::endl;
    DLOG(INFO) << std::endl;
    DLOG(INFO) << "HdSignSpdLmtCalu_Trg01: " << HdSignSpdLmtCalu_Trg01 << std::endl;
    DLOG(INFO) << "SignSpdLmtCalu_Trg01: " << SignSpdLmtCalu_Trg01 << "\tSignSpdLmtCalu_Trg02: " << SignSpdLmtCalu_Trg02 << std::endl;
    DLOG(INFO) << "curspd: " << VehCurSpd << "\tSlecSpdLmt_id: " << int(SlecSpdLmt_id)
               << "\tSlecSpdVal: " << SlecSpdVal << "\tSpdLmtdist: " << SlecSpdDist
               << "\tSignSpdLimt_Updist: " << SignSpdLimt_Updist << std::endl;
#endif
}

// void LgtSpdLmt::LgtSpdLmtInfoMatchProc(const ADC::PD_LgtSpdLmt::LastCyc_SpdLmtInfo &spdlmtinfo) // match lgtspdval and lgtspddist with lgtspdflg and type
// {
//     // this->lastcyc_spdlmtinfo.LastCyc_SpdLmtFlg = spdlmtinfo.LastCyc_SpdLmtFlg;
//     // this->lastcyc_spdlmtinfo.LastCyc_SpdLmtId = spdlmtinfo.LastCyc_SpdLmtId;
//     // this->lastcyc_spdlmtinfo.LastCyc_SpdLmtType = spdlmtinfo.LastCyc_SpdLmtType;

//     if (spdlmtinfo.LastCyc_SpdLmtFlg == true && (SignSpdLmtCalu_Trg01 == false) && (spdlmtinfo.LastCyc_SpdLmtId == SlecSpdLmt_id))
//     {
//         SignSpdLmtCalu_Trg01 = true;
//     }
// }

// according to SpdLmt type to match SpdLmtID

uint8_t LgtSpdLmt::SpdLmtType2MatchID(const ADC::PD_LgtSpdLmt::LastCyc_SpdLmtInfo &spdlmtinfo)
{
    uint8_t ChkSpdLmt_ID = 0;
    if (spdlmtinfo.LastCyc_SpdLmtType == 1)
    {
        ChkSpdLmt_ID = SlecSpdLmt_id;
    }
    else if (spdlmtinfo.LastCyc_SpdLmtType == 2)
    {
        ChkSpdLmt_ID = SlecSpdLmt_id_2nd;
    }

    return ChkSpdLmt_ID;
}

// distance sample-step calculation
void LgtSpdLmt::DistSampCalu_01(const PD::PD_Input &pd_input)
{
    float DistSampStep_01 = 0.0f;

    DistSampStep_01 = (SignSpdLimt_Updist - SignSpdLimt_Lowdist) / SAMPLEPNTNUM;

    Sample_ST sample_st01;
    // DLOG(INFO) << "********************************" << std::endl;
    // DLOG(INFO) << "SpdLmt_updist: " << SignSpdLimt_Updist << "\tSpdLmt_lowdist: " << SignSpdLimt_Lowdist << std::endl;

    // to get different sample distance
    for (int i = 0; i <= SAMPLEPNTNUM; i++)
    {

        sample_st01.s_end = SignSpdLimt_Lowdist + i * DistSampStep_01;

        sample_st01.a = (pow(SlecSpdVal, 2) - pow(pd_input.VSE_LgtVehSpd, 2)) / (2 * sample_st01.s_end + 1);

        sample_st01.t = fabs((SlecSpdVal - pd_input.VSE_LgtVehSpd) / (sample_st01.a));

        // DLOG(INFO) << "samp_st01 s: " << sample_st01.s_end << "\tsamp_st01 a: " << sample_st01.a << "\tsamp_st01 tm: " << sample_st01.t << std::endl;

        // to get different acceleration in diferent sample distance
        Samp_Dist_Pnt01.emplace_back(sample_st01);
    }
    // DLOG(INFO) << "********************************" << std::endl;

    // return Samp_Dist_Pnt01;
}

void LgtSpdLmt::DistSampCalu_02(const PD::PD_Input &pd_input)
{

    float DistSampStep_02 = 0.0f;

    DistSampStep_02 = (SignSpdLimt_Updist_2nd - SignSpdLimt_Lowdist_2nd) / SAMPLEPNTNUM;

    Sample_ST sample_st02;

    for (int j = 0; j <= SAMPLEPNTNUM; j++)
    {
        sample_st02.s_end = SignSpdLimt_Lowdist_2nd + j * DistSampStep_02;

        sample_st02.a = (pow(SlecSpdVal_2nd, 2) - pow(pd_input.VSE_LgtVehSpd, 2)) / (2 * sample_st02.s_end + 1);

        sample_st02.t = fabs((SlecSpdVal_2nd - pd_input.VSE_LgtVehSpd) / (sample_st02.a));

        // to get different acceleration in diferent sample distance
        Samp_Dist_Pnt02.emplace_back(sample_st02);
    }

    // return Samp_Dist_Pnt02;
}

// calculate sign01 lgtspd limit
void LgtSpdLmt::SignSpdLmtCalu_Coe01(const PD::PD_Input &pd_input)
{
    // float egovhespd = pd_input.VSE_LgtVehSpd;
    // initial state
    float s_start = 0.0f;
    float v_start = pd_input.VSE_LgtVehSpd;
    float a_start = pd_input.VSE_LatAcc;

    // end state

    float a_end = 0;
    float v_end = SlecSpdVal;
    DistSampCalu_01(pd_input);

    // calculate different distance sample point coefficient (coefficient solution is same as lgtdisttraj_coefficient)
    LgtTraj_Coefficient lgtspdlmt_coe01;

    for (auto iter = Samp_Dist_Pnt01.begin(); iter != Samp_Dist_Pnt01.end(); iter++)
    {
        lgtspdlmt_coe01.tm = (*iter).t;
        lgtspdlmt_coe01.c0 = s_start;
        lgtspdlmt_coe01.c1 = v_start;
        lgtspdlmt_coe01.c2 = 0.5 * a_start;
        lgtspdlmt_coe01.c3 = -(20 * s_start - 20 * (*iter).s_end - pow((*iter).t, 2) * a_end + 3 * pow((*iter).t, 2) * a_start + 8 * (*iter).t * v_end + 12 * (*iter).t * v_start) / (2 * pow((*iter).t, 3));
        lgtspdlmt_coe01.c4 = (30 * s_start - 30 * (*iter).s_end - 2 * pow((*iter).t, 2) * a_end + 3 * pow((*iter).t, 2) * a_start + 14 * (*iter).t * v_end + 16 * (*iter).t * v_start) / (2 * pow((*iter).t, 4));
        lgtspdlmt_coe01.c5 = -(12 * s_start - 12 * (*iter).s_end - pow((*iter).t, 2) * a_end + pow((*iter).t, 2) * a_start + 6 * (*iter).t * v_end + 6 * (*iter).t * v_start) / (2 * pow((*iter).t, 5));
        lgtspdlmt_coevec01.emplace_back(lgtspdlmt_coe01);
    }
}

void LgtSpdLmt::SignSpdLmtCalu_Coe02(const PD::PD_Input &pd_input)
{
    // float egovhespd = pd_input.VSE_LgtVehSpd;
    // initial state
    float s_start = 0.0f;
    float v_start = pd_input.VSE_LgtVehSpd;
    float a_start = pd_input.VSE_LatAcc;

    // end state
    // std::vector<float> s_end01;
    DistSampCalu_02(pd_input);
    float v_end = SlecSpdVal_2nd;
    float a_end = 0;

    // calculate different distance sample point coefficient (coefficient solution is same as lgtdisttraj_coefficient)
    LgtTraj_Coefficient lgtspdlmt_coe02;

    for (auto iter = Samp_Dist_Pnt02.begin(); iter != Samp_Dist_Pnt02.end(); iter++)
    {
        lgtspdlmt_coe02.tm = (*iter).t;
        lgtspdlmt_coe02.c0 = s_start;
        lgtspdlmt_coe02.c1 = v_start;
        lgtspdlmt_coe02.c2 = 0.5 * a_start;
        lgtspdlmt_coe02.c3 = -(20 * s_start - 20 * (*iter).s_end - pow((*iter).t, 2) * a_end + 3 * pow((*iter).t, 2) * a_start + 8 * (*iter).t * v_end + 12 * (*iter).t * v_start) / (2 * pow((*iter).t, 3));
        lgtspdlmt_coe02.c4 = (30 * s_start - 30 * (*iter).s_end - 2 * pow((*iter).t, 2) * a_end + 3 * pow((*iter).t, 2) * a_start + 14 * (*iter).t * v_end + 16 * (*iter).t * v_start) / (2 * pow((*iter).t, 4));
        lgtspdlmt_coe02.c5 = -(12 * s_start - 12 * (*iter).s_end - pow((*iter).t, 2) * a_end + pow((*iter).t, 2) * a_start + 6 * (*iter).t * v_end + 6 * (*iter).t * v_start) / (2 * pow((*iter).t, 5));
        lgtspdlmt_coevec02.emplace_back(lgtspdlmt_coe02);
    }
}

void LgtSpdLmt::Sign_OptmalSpdLmtSlect(const PD::PD_Input &pd_input)
{

    if (SignSpdLmtCalu_Trg01 == true && SignSpdLmtCalu_Trg02 == false)
    {
        SignSpdLmtCalu_Coe01(pd_input);
    }
    else if (SignSpdLmtCalu_Trg01 == true && SignSpdLmtCalu_Trg02 == true)
    {
        SignSpdLmtCalu_Coe01(pd_input);
        SignSpdLmtCalu_Coe02(pd_input);
    }
}

std::vector<float> LgtSpdLmt::LgtSpdLmt_JerkCost(const std::vector<LgtTraj_Coefficient> &lgtspdlmt_coevec)
{
    // LgtSpdLmt_SampJk lgtspdlmt_sampjk;
    Sample_ST_Jerkpnt lgtspdlmt_sampjk;

    LgtTraj_Jerk_Info lgtspdlmt_jkinfo;
    // LgtSpdLmt_JkInfo ;
    std::vector<LgtTraj_Jerk_Info> pd_lgtspdlmt_jkinfo;

    // LgtSpdLmt_TrjPnt lgtspdlmt_trjpnt01;

    for (int i = 0; i < lgtspdlmt_coevec.size(); i++)
    {
        for (float tm_stp = 0.0; tm_stp <= lgtspdlmt_coevec.at(i).tm + HOLDVAL; tm_stp = tm_stp + 0.1) // to get sample time acc and jerk info
        {

            lgtspdlmt_sampjk.t = tm_stp;

            lgtspdlmt_sampjk.jerkval = 6 * lgtspdlmt_coevec.at(i).c3 + 24 * lgtspdlmt_coevec.at(i).c4 * tm_stp +
                                       60 * lgtspdlmt_coevec.at(i).c5 * pow(tm_stp, 2);

            lgtspdlmt_jkinfo.pd_lgttraj_jerk.emplace_back(lgtspdlmt_sampjk); // store each trajectory each point jerk value
            // lgtspdlmt_jkinfo.
        }
        // pd_lgtspdlmt_coe.
        lgtspdlmt_jkinfo.coefficient.clear();
        // lgtspdlmt_jkinfo.pd_lgtspdlmt_coe.emplace_back
        lgtspdlmt_jkinfo.coefficient.emplace_back(lgtspdlmt_coevec[i]); // to get trajectory conefficient

        pd_lgtspdlmt_jkinfo.emplace_back(lgtspdlmt_jkinfo);
    }

    // select optimal lgtspdmit coefficient with cost function

    float lgtspdlmt_timestep = 0.1f; // time width
    std::vector<float> lgtspdavgacc;

    std::vector<float> temp_pd_lgtspdlmt_jerkcost;

    lgtspdavgacc = LgtSpdLmtAvgAccProc();

    // std::cout << "lgtspdacc size: " << lgtspdavgacc.size() << "\tpd_lgtspdlmt_jkinfo: " << pd_lgtspdlmt_jkinfo.size() << std::endl;

    for (int jkindx = 0; jkindx < pd_lgtspdlmt_jkinfo.size(); jkindx++)
    {

        float sum_lgtspdlmt = 0.0f;

        for (int i = 0; i < pd_lgtspdlmt_jkinfo[jkindx].pd_lgttraj_jerk.size(); i++)
        {
            // sum_lgtspdlmt = sum_lgtspdlmt + lgtspdlmt_timestep * pow(pd_lgtspdlmt_jkinfo[jkindx].pd_lgtspdlmt_jerk[i].jerkval, 2); // jerk value square
            sum_lgtspdlmt = sum_lgtspdlmt + lgtspdlmt_timestep * pow(pd_lgtspdlmt_jkinfo[jkindx].pd_lgttraj_jerk[i].jerkval, 2); // jerk value square
        }

        // float tm_lgtspdlmt = pd_lgtspdlmt_jkinfo[jkindx].pd_lgtspdlmt_coe.front().tm;
        float tm_lgtspdlmt = pd_lgtspdlmt_jkinfo[jkindx].coefficient.front().tm;
        // analysis data
        // DLOG(INFO) << jkindx << "\ttm_lgtspdlmt: " << tm_lgtspdlmt << "\tsum_lgtspdlmt: " << sum_lgtspdlmt << std::endl;

        temp_pd_lgtspdlmt_jerkcost.emplace_back(Kt_spdlmt * tm_lgtspdlmt + Kj_spdlmt * sum_lgtspdlmt + Ka_spdlmt * pow(lgtspdavgacc.at(jkindx), 2));
    }

    // analysis data
    //  for(int i = 0; i < temp_pd_lgtspdlmt_jerkcost)

    return temp_pd_lgtspdlmt_jerkcost;
}

void LgtSpdLmt::SignSpdLmt_OptmalTrj(const PD::PD_Input &pd_input)
{
    Sign_OptmalSpdLmtSlect(pd_input);

    if (!lgtspdlmt_coevec01.empty())
    {

        pd_lgtspdlmt_jerkcost01 = LgtSpdLmt_JerkCost(lgtspdlmt_coevec01);

        // analysis data
        // for (int i = 0; i < pd_lgtspdlmt_jerkcost01.size(); i++)
        // {
        //     DLOG(INFO) << i << "\tjerkcost01: " << pd_lgtspdlmt_jerkcost01[i] << std::endl;
        // }
    }
    if (!lgtspdlmt_coevec02.empty())
    {

        pd_lgtspdlmt_jerkcost02 = LgtSpdLmt_JerkCost(lgtspdlmt_coevec02);
        // analysis data
        // for (int j = 0; j < pd_lgtspdlmt_jerkcost01.size(); j++)
        // {
        //     DLOG(INFO) << j << "\tjerkcost02: " << pd_lgtspdlmt_jerkcost01[j] << std::endl;
        // }
    }

    // select optimal trajectory
    if (!pd_lgtspdlmt_jerkcost01.empty())
    {
        LgtSpdLmt01_MinJerkValIndx = min_element(pd_lgtspdlmt_jerkcost01.begin(), pd_lgtspdlmt_jerkcost01.end()) - pd_lgtspdlmt_jerkcost01.begin();
        LgtSpdLmt01_StsFlag = true;
    }

    if (!pd_lgtspdlmt_jerkcost02.empty())
    {
        LgtSpdLmt02_MinJerkValIndx = min_element(pd_lgtspdlmt_jerkcost02.begin(), pd_lgtspdlmt_jerkcost02.end()) - pd_lgtspdlmt_jerkcost02.begin();
        LgtSpdLmt02_StsFlag = true;
    }
    DLOG(INFO) << "01Indx: " << LgtSpdLmt01_MinJerkValIndx
               << "\t02Indx: " << LgtSpdLmt02_MinJerkValIndx << std::endl;

    float LgtSpdLmt_ThrsDistVal = 50.0f; // lgtspdlmt enable threshold value

    if (LgtSpdLmt01_StsFlag == true && LgtSpdLmt02_StsFlag == false)
    {

        LgtSpdLmt_DistVal = SlecSpdDist - Samp_Dist_Pnt01.at(LgtSpdLmt01_MinJerkValIndx).s_end;
        if (LgtSpdLmt_DistVal <= LgtSpdLmt_ThrsDistVal)
        {
            // LgtSpdLmt_DistVal = Samp_Dist_Pnt01.at(LgtSpdLmt01_MinJerkValIndx).s_end;  //
            LgtSpdLmt_DistVal = SlecSpdDist;
            LgtSpdLmt_SpdLmtFlg = true;
            LgtSpdLmt_SpdVal = SlecSpdVal;
            LgtSpdLmt_type = static_cast<uint8_t>(1);
            OptimalSignSpdLmt_Indx = LgtSpdLmt01_MinJerkValIndx;
        }
    }
    else if (LgtSpdLmt01_StsFlag == true && LgtSpdLmt02_StsFlag == true)
    {
        // DLOG(INFO) << "LgtSpdLmt01_MinJerkValIndx: " << LgtSpdLmt01_MinJerkValIndx << std::endl;
        // DLOG(INFO) << "LgtSpdLmt02_MinJerkValIndx: " << LgtSpdLmt02_MinJerkValIndx << std::endl;
        // DLOG(INFO) << "Samp_Dist_Pnt01 size: " << Samp_Dist_Pnt01.size() << std::endl;
        // DLOG(INFO) << "Samp_Dist_Pnt02 size: " << Samp_Dist_Pnt02.size() << std::endl;
        if (!Samp_Dist_Pnt01.empty() && (Samp_Dist_Pnt01.size() > LgtSpdLmt01_MinJerkValIndx))
        {
            LgtSpdLmt_DistVal01 = SlecSpdDist - Samp_Dist_Pnt01.at(LgtSpdLmt01_MinJerkValIndx).s_end;
            // DLOG(INFO) << "sle_dist01: " << SlecSpdDist
            //            << "\tsamp_dist01_send: " << Samp_Dist_Pnt01.at(LgtSpdLmt01_MinJerkValIndx).s_end
            //            << "\tLgtSpdLmt_DistVal01: " << LgtSpdLmt_DistVal01 << std::endl;
        }
        if (!Samp_Dist_Pnt02.empty() && (Samp_Dist_Pnt02.size() > LgtSpdLmt02_MinJerkValIndx))
        {
            LgtSpdLmt_DistVal02 = SlecSpdDist_2nd - Samp_Dist_Pnt02.at(LgtSpdLmt02_MinJerkValIndx).s_end;

            // DLOG(INFO) << "slec_dist02: " << SlecSpdDist_2nd
            //            << "\tsamp_dist02_send: " << Samp_Dist_Pnt02.at(LgtSpdLmt02_MinJerkValIndx).s_end
            //            << "\tLgtSpdLmt_DistVal02: " << LgtSpdLmt_DistVal02 << std::endl;
        }

        if ((LgtSpdLmt_DistVal02 <= LgtSpdLmt_ThrsDistVal) && (SignSpdLmtCalu_Trg02 == true))
        {
            LgtSpdLmt_DistVal = SlecSpdDist_2nd;
            LgtSpdLmt_SpdLmtFlg = true;
            LgtSpdLmt_SpdVal = SlecSpdVal_2nd;
            LgtSpdLmt_type = static_cast<uint8_t>(2);
            OptimalSignSpdLmt_Indx = LgtSpdLmt02_MinJerkValIndx;
            // DLOG(INFO) << "02"<< std::endl;
        }
        if ((LgtSpdLmt_DistVal01 <= LgtSpdLmt_ThrsDistVal) && (SignSpdLmtCalu_Trg01 == true))
        {
            LgtSpdLmt_DistVal = SlecSpdDist;
            LgtSpdLmt_SpdLmtFlg = true;
            LgtSpdLmt_SpdVal = SlecSpdVal;
            LgtSpdLmt_type = static_cast<uint8_t>(1);
            OptimalSignSpdLmt_Indx = LgtSpdLmt01_MinJerkValIndx;
            // DLOG(INFO) << "01"<< std::endl;
        }
    }
#ifdef GLOG
    DLOG(INFO) << std::endl;
    DLOG(INFO) << "coevec01_sz: " << lgtspdlmt_coevec01.size() << "\tjerkcost01_sz: " << pd_lgtspdlmt_jerkcost01.size() << std::endl;
    DLOG(INFO) << "coevec02_sz: " << lgtspdlmt_coevec02.size() << "\tjerkcost02_sz: " << pd_lgtspdlmt_jerkcost01.size() << std::endl;
    DLOG(INFO) << "LgtSpdLmt01_StsFlag: " << LgtSpdLmt01_StsFlag << "\tTrg01: " << SignSpdLmtCalu_Trg01 << "\tTrg02: " << SignSpdLmtCalu_Trg02 << std::endl;
    DLOG(INFO) << "SpdLmtFlg: " << LgtSpdLmt_SpdLmtFlg << std::endl;

    DLOG(INFO) << "distval01: " << LgtSpdLmt_DistVal01 << "\tdistval02: " << LgtSpdLmt_DistVal02 << std::endl;
    DLOG(INFO) << "Egospd: " << pd_input.VSE_LgtVehSpd << "\tLgtSpdLmt_SpdVal: " << LgtSpdLmt_SpdVal << "\tSpdLmtDist: "
               << LgtSpdLmt_DistVal << "\tspdlmt_type: " << int(LgtSpdLmt_type) << "\tOpt_Indx: " << int(OptimalSignSpdLmt_Indx) << std::endl;

    // DLOG(INFO) << "\tLastCyc_SpdLmtId: " << int(spdlmtinfo.LastCyc_SpdLmtId)
    DLOG(INFO) << std::endl;
#endif
    // std::cout << "*****" << std::endl;
    // std::cout << "distval01: " << LgtSpdLmt_DistVal01 << "\tSpdLmtFlg: " << LgtSpdLmt_SpdLmtFlg << std::endl;
    // std::cout << "*****" << std::endl;
}

void LgtSpdLmt::LgtSpdLmt_ST_trace()
{
    LgtTraj_Coefficient lgtspdlmt_coe;

    if (LgtSpdLmt_SpdLmtFlg == true && (LgtSpdLmt_type == static_cast<uint8_t>(1)))
    {
        lgtspdlmt_coe.c0 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c0;
        lgtspdlmt_coe.c1 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c1;
        lgtspdlmt_coe.c2 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c2;
        lgtspdlmt_coe.c3 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c3;
        lgtspdlmt_coe.c4 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c4;
        lgtspdlmt_coe.c5 = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).c5;
        lgtspdlmt_coe.tm = lgtspdlmt_coevec01.at(LgtSpdLmt01_MinJerkValIndx).tm;
    }
    else
    {
        if (!lgtspdlmt_coevec02.empty())
        {
            if (LgtSpdLmt_SpdLmtFlg == true && (LgtSpdLmt_type == static_cast<uint8_t>(2)))
            {
                lgtspdlmt_coe.c0 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c0;
                lgtspdlmt_coe.c1 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c1;
                lgtspdlmt_coe.c2 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c2;
                lgtspdlmt_coe.c3 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c3;
                lgtspdlmt_coe.c4 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c4;
                lgtspdlmt_coe.c5 = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).c5;
                lgtspdlmt_coe.tm = lgtspdlmt_coevec02.at(LgtSpdLmt02_MinJerkValIndx).tm;
            }
        }
    }

    // calculate lgt speed limit trajectory point:
    // LgtSpdLmt_TrjPnt lgtspdlmt_trjpnt;
    PD_LgtTrj_ST_point lgtspdlmt_trjpnt;
    // DLOG(INFO) <<
    // DLOG(INFO) << "SpdLmt_tm: " << lgtspdlmt_coe.tm << std::endl;
    // DLOG(INFO) << std::endl;
    for (float i = 0.0f; i < lgtspdlmt_coe.tm + 0.01; i = i + 0.1)
    {
        lgtspdlmt_trjpnt.t = i;
        lgtspdlmt_trjpnt.s = lgtspdlmt_coe.c0 +
                             lgtspdlmt_coe.c1 * i +
                             lgtspdlmt_coe.c2 * i * i +
                             lgtspdlmt_coe.c3 * i * i * i +
                             lgtspdlmt_coe.c4 * i * i * i * i +
                             lgtspdlmt_coe.c5 * i * i * i * i * i;

        lgtspdlmt_trjpnt.vx = lgtspdlmt_coe.c1 +
                              2 * lgtspdlmt_coe.c2 * i +
                              3 * lgtspdlmt_coe.c3 * i * i +
                              4 * lgtspdlmt_coe.c4 * i * i * i +
                              5 * lgtspdlmt_coe.c5 * i * i * i * i;

        lgtspdlmt_trjpnt.ax = 2 * lgtspdlmt_coe.c2 +
                              6 * lgtspdlmt_coe.c3 * i +
                              12 * lgtspdlmt_coe.c4 * i * i +
                              20 * lgtspdlmt_coe.c5 * i * i * i;

        lgtspdlmt_trjpnt.jkx = 6 * lgtspdlmt_coe.c3 +
                               24 * lgtspdlmt_coe.c4 * i +
                               60 * lgtspdlmt_coe.c5 * i * i;
        // lgtspdlmt_trjpnt.pd_lgtspdlmt_coe = lgtspdlmt_coe;
        pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.emplace_back(lgtspdlmt_trjpnt);
    }
    // pd_lgtspdlmt_st_trace.pd_lgtspdlmt_coe = lgtspdlmt_coe;
    pd_lgtspdlmt_st_trace.lgttrj_st_coe = lgtspdlmt_coe;

    // analysis data
    // if (LgtSpdLmt_SpdLmtFlg == true)
    // {
    //     DLOG(INFO) << "SpdLmtTrjPnt" << std::endl;
    //     DLOG(INFO) << "SpdLmt_tm: " << pd_lgtspdlmt_st_trace.lgttrj_st_coe.tm << std::endl;
    //     for (int i = 0; i < pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.size(); i++)
    //     {
    //         DLOG(INFO) << i << "spdlmt_s: " << pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.at(i).s
    //                    << "\tspdlmt_vx: " << pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.at(i).vx
    //                    << "\tspdlmt_ax: " << pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.at(i).ax
    //                    << "\tspdlmt_jk: " << pd_lgtspdlmt_st_trace.pd_lgttrj_st_trace.at(i).jkx << std::endl;
    //     }
    // }
}

std::vector<float> LgtSpdLmt::LgtSpdLmtAvgAccProc()
{
    // int datasize = 11;
    std::vector<float> avg_ax;
    LgtTraj_Coefficient test_lgtspdlmt_coe;

    std::vector<test_STInfo> test_lgtspdlmt_trace;

    test_STInfo test_pd_lgttrj_stinfo;

    if (!lgtspdlmt_coevec01.empty())
    {
        PD_LgtTrj_ST_point test_lgtspdlmt_trjpnt;

        for (int j = 0; j < lgtspdlmt_coevec01.size(); j++) // for each coefficient
        {
            test_pd_lgttrj_stinfo.pd_lgttrj_st_trace.clear();
            for (float i = 0.0f; i < lgtspdlmt_coevec01.at(j).tm; i = i + 0.1) // for time in each coefficient
            {
                test_lgtspdlmt_trjpnt.t = i;
                test_lgtspdlmt_trjpnt.s = lgtspdlmt_coevec01.at(j).c0 +
                                          lgtspdlmt_coevec01.at(j).c1 * i +
                                          lgtspdlmt_coevec01.at(j).c2 * i * i +
                                          lgtspdlmt_coevec01.at(j).c3 * i * i * i +
                                          lgtspdlmt_coevec01.at(j).c4 * i * i * i * i +
                                          lgtspdlmt_coevec01.at(j).c5 * i * i * i * i * i;

                test_lgtspdlmt_trjpnt.vx = lgtspdlmt_coevec01.at(j).c1 +
                                           2 * lgtspdlmt_coevec01.at(j).c2 * i +
                                           3 * lgtspdlmt_coevec01.at(j).c3 * i * i +
                                           4 * lgtspdlmt_coevec01.at(j).c4 * i * i * i +
                                           5 * lgtspdlmt_coevec01.at(j).c5 * i * i * i * i;

                test_lgtspdlmt_trjpnt.ax = 2 * lgtspdlmt_coevec01.at(j).c2 +
                                           6 * lgtspdlmt_coevec01.at(j).c3 * i +
                                           12 * lgtspdlmt_coevec01.at(j).c4 * i * i +
                                           20 * lgtspdlmt_coevec01.at(j).c5 * i * i * i;

                test_lgtspdlmt_trjpnt.jkx = 6 * lgtspdlmt_coevec01.at(j).c3 +
                                            24 * lgtspdlmt_coevec01.at(j).c4 * i +
                                            60 * lgtspdlmt_coevec01.at(j).c5 * i * i;

                test_pd_lgttrj_stinfo.pd_lgttrj_st_trace.emplace_back(test_lgtspdlmt_trjpnt);
            }

            test_pd_lgttrj_stinfo.lgttrj_st_coe.clear();

            test_pd_lgttrj_stinfo.lgttrj_st_coe.emplace_back(lgtspdlmt_coevec01.at(j));

            test_lgtspdlmt_trace.emplace_back(test_pd_lgttrj_stinfo);
        }

        // cout all spdlimt pnt
        // if (LgtSpdLmt_SpdLmtFlg == true)
        if (!test_lgtspdlmt_trace.empty())
        {
            for (int i = 0; i < test_lgtspdlmt_trace.size(); i++)
            {
                // DLOG(INFO) << "All lgtspdpnt" << std::endl;
                // DLOG(INFO) << i << "\tspdlgt_tm: " << test_lgtspdlmt_trace.at(i).lgttrj_st_coe.front().tm << std::endl;
                float sum_ax = 0.0f;

                int size_ax = 0;
                for (int j = 0; j < test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.size(); j++)
                {
                    // DLOG(INFO) << "spdlmt_s: " << test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.at(j).s
                    //            << "\tspdlmt_vx: " << test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.at(j).vx
                    //            << "\tspdlmt_ax: " << test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.at(j).ax
                    //            << "\tspdlmt_jk: " << test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.at(j).jkx << std::endl;

                    sum_ax = sum_ax + test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.at(j).ax;
                    size_ax = test_lgtspdlmt_trace.at(i).pd_lgttrj_st_trace.size();
                }
#ifdef GLOG
                DLOG(INFO) << i << "\tspdlgt_tm: " << test_lgtspdlmt_trace.at(i).lgttrj_st_coe.front().tm << "\tavg_ax: " << (sum_ax / size_ax) << std::endl;
                DLOG(INFO) << std::endl;
#endif
                avg_ax.emplace_back(sum_ax / size_ax);
            }
        }
    }

    return avg_ax;
}

void LgtSpdLmt::process(const PD::PD_Input &pd_input)
{
    SignSpdLmt_OptmalTrj(pd_input);
    LgtSpdLmt_ST_trace();
    // DataAnalysis();
}
